class GitXplorer::GitObject::File < GitXplorer::GitObject
    def children
        if (@kids.nil?)
            # Initialize
            @kids = Array.new

            # Create git command
            cmd = [
                "git log --date=format-local:\"%F_%I:%M:%S_%P\"",
                "--diff-filter=AC",
                "--full-history",
                "--pretty=tformat:\"{{%H}}{{%s}}{{%cd}}{{%an}}\"",
                "--",
                absolute_path
            ].join(" ")

            # Loop thru results creating a revision object for each
            %x(#{cmd}).split("\n").each do |line|
                line.match(/{{(.+)}}{{(.+)}}{{(.+)}}{{(.+)}}/) do |m|
                    @kids.push(
                        GitXplorer::GitObject::Revision.new(
                            m[1],
                            self,
                            m[2],
                            m[3],
                            m[4]
                        )
                    )
                end
            end
        end

        return @kids
    end

    def desc
        return "#{newest.name} #{newest.date}" if (newest)
        return nil
    end

    def initialize(name, parent)
        super(name, parent)
    end

    def newest
        return children[0]
    end
end
