class GitXplorer::GitObject::Revision < GitXplorer::GitObject
    attr_reader :date
    attr_reader :summary
    attr_reader :user

    def desc
        return "#{@date} #{@user} #{@summary}"
    end

    def initialize(revision, parent, summary, date, user)
        super(revision, parent)
        @date = date
        @summary = summary
        @user = user
    end

    def tab_complete(color = false)
        color ||= false
        return {@name => @date}
    end
end
