require "djinni"

class CatWish < Djinni::Wish
    def aliases
        return ["cat"]
    end

    def description
        return "Display file contents"
    end

    def execute(args, djinni_env = Hash.new)
        gitx = djinni_env["gitXplorer"]

        begin
            gitx.show(args)
        rescue GitXplorer::Error => e
            puts e.message
        end
    end

    def tab_complete(input, djinni_env = Hash.new)
        gitx = djinni_env["gitXplorer"]

        _, found, partial = input.rpartition(":")
        _, _, partial = input.rpartition("/") if (found.empty?)

        completions = Hash.new
        gitx.get_completions(input).each do |child|
            completions.merge!(child.tab_complete)
        end

        return [completions, partial, ""]
    end

    def usage
        puts "#{aliases.join(", ")} <file>"
        puts "    #{description}."
    end
end
