require "djinni"

class FindWish < Djinni::Wish
    def aliases
        return ["find"]
    end

    def description
        return "Similar to \"find . -iregex PATTERN\""
    end

    def execute(args, djinni_env = Hash.new)
        gitx = djinni_env["gitXplorer"]
        args.gsub!(/^(["'])(.*)\1$/, "\\2")
        dir = gitx.pwd.gsub(%r{^[^/]+(/|$)}, "")

        begin
            puts gitx.get_filenames(dir, args)
        rescue GitXplorer::Error => e
            puts e.message
        end
    end

    def usage
        puts "#{aliases.join(", ")} [PATTERN]"
        puts "    #{description}."
    end
end
