require "djinni"

class GitWish < Djinni::Wish
    def aliases
        return ["git"]
    end

    def description
        return "Run any git command"
    end

    def execute(args, djinni_env = Hash.new)
        gitx = djinni_env["gitXplorer"]
        begin
            case args
            when /^\s*(diff|ls-files|rev-parse|show|status).*/
                puts gitx.git(args, false)
            else
                puts gitx.git(args)
            end
        rescue GitXplorer::Error => e
            puts e.message
        end
    end

    def usage
        puts "#{aliases.join(", ")}"
        puts "    #{description}."
    end
end
