require "djinni"

class ViWish < Djinni::Wish
    def aliases
        return ["vi", "view", "vim"]
    end

    def description
        return "Open the file in vim"
    end

    def execute(args, djinni_env = Hash.new)
        gitx = djinni_env["gitXplorer"]

        readonly = false
        case djinni_env["djinni_input"]
        when "view"
            readonly = true
        end

        begin
            gitx.vim(args, readonly)
        rescue GitXplorer::Error => e
            puts e.message
        end
    end

    def tab_complete(input, djinni_env = Hash.new)
        gitx = djinni_env["gitXplorer"]

        _, found, partial = input.rpartition(":")
        _, _, partial = input.rpartition("/") if (found.empty?)

        completions = Hash.new
        gitx.get_completions(input).each do |child|
            completions.merge!(child.tab_complete)
        end

        return [completions, partial, ""]
    end

    def usage
        puts "#{aliases.join(", ")} <file>"
        puts "    #{description}."
    end
end
